#include <stdio.h>
#include <string.h>
#include <conio.h>

FILE *infile;
FILE *outfile;
int chan;
long Rx, Tx;
long A, N;
char Data [100];
int Line;
unsigned char ch[16];



void main (void)

{
    int temp;
    
    
    outfile = fopen ("KM80.BIN","w+b");
    ch[0] = 0xFF;
    for (temp=0; temp < 4096; temp++)
	fwrite (ch, 1, 1, outfile);
    if (NULL == (infile = fopen ("KM80.PRG", "r"))) {
	fclose (outfile);
	printf ("Error opening file: KM80.PRG\n");
	exit (0);
    }
    Line = 0;

    while (1) {
	fgets (Data, 95, infile);
	if (feof (infile)) {
	    break;
	}
	temp = sscanf (Data, "%d %ld %ld", &chan, &Rx, &Tx);
	if (temp != 3) {
	    break;
	}
	
	Tx /= 125;
	N = Tx / 64;
	A = Tx % 64;
	ch[0] = (unsigned char)(A % 16) | 0xF0;
	ch[1] = (unsigned char)(A / 16) | 0xF0;
	ch[2] = (unsigned char)(N % 16) | 0xF0;
	ch[3] = (unsigned char)((N % 256) / 16) | 0xF0;
	ch[4] = (unsigned char)(N / 256) | 0xF0;
	ch[5] = 0xFC;
	ch[6] = 0xF3;
	ch[7] = 0xF0;

	Rx +=216000;
	Rx /= 125;
	N = Rx / 64;
	A = Rx % 64;	
	ch[8] = (unsigned char)(A % 16) | 0xF0;
	ch[9] = (unsigned char)(A / 16) | 0xF0;
	ch[10] = (unsigned char)(N % 16) | 0xF0;
	ch[11] = (unsigned char)((N % 256) / 16) | 0xF0;
	ch[12] = (unsigned char)(N / 256) | 0xF0;
	ch[13] = 0xFC;
	ch[14] = 0xF3;
	ch[15] = 0xF0;	
	for (temp=0; temp < 16; temp++) {
	    printf ("%02X ",ch[temp]);
	}
	printf ("\n");
	fseek (outfile, (chan-1) * 16, SEEK_SET);
	fwrite (ch, 16, 1, outfile);
	
	Line++;
	
    }
    fclose (infile);
    fclose (outfile);
    printf ("Processing Succesfully Completed !\n");
    printf ("Channels Programmed: %d\n", Line);

}/* main */